Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftmx.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftmx.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftmx.F90	(revision 3211)
@@ -48,4 +48,10 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   az_tmx     ! coefficient used to evaluate the tidal induced Kz
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+!FTRANS az_tmx :I :I :z
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -110,4 +116,7 @@
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
       REAL(wp) ::   ztpc         ! scalar workspace
+#if defined key_z_first
+      REAL(wp) ::   ztpc         ! scalar workspace
+#endif
       !!----------------------------------------------------------------------
 
@@ -132,13 +141,30 @@
       END DO
 
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            zscal = MIN( zkz(ji,jj), 30./6. )   !kz max = 300 cm2/s
+            DO jk = 2, jpkm1        !* Mutiply by zkz to recover en_tmx, BUT bound by 30/6 ==> zav_tide bound by 300 cm2/s
+               zav_tide(ji,jj,jk) = zav_tide(ji,jj,jk) * zscal
+            END DO
+         END DO
+      END DO
+#else
       DO jk = 2, jpkm1              !* Mutiply by zkz to recover en_tmx, BUT bound by 30/6 ==> zav_tide bound by 300 cm2/s
          zav_tide(:,:,jk) = zav_tide(:,:,jk) * MIN( zkz(:,:), 30./6. )   !kz max = 300 cm2/s
       END DO
+#endif
 
       IF( kt == nit000 ) THEN       !* check at first time-step: diagnose the energy consumed by zav_tide
          ztpc = 0.e0
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpk
+#else
          DO jk= 1, jpk
             DO jj= 1, jpj
                DO ji= 1, jpi
+#endif
                   ztpc = ztpc + fse3w(ji,jj,jk) * e1t(ji,jj) * e2t(ji,jj)   &
                      &         * MAX( 0.e0, rn2(ji,jj,jk) ) * zav_tide(ji,jj,jk) * tmask(ji,jj,jk) * tmask_i(ji,jj)
@@ -159,4 +185,23 @@
       !                          !   Update  mixing coefs  !                          
       !                          ! ----------------------- !
+#if defined key_z_first
+      !* update momentum & tracer diffusivity with tidal mixing
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 2, jpkm1 
+               avt(ji,jj,jk) = avt(ji,jj,jk) + zav_tide(ji,jj,jk)
+               avm(ji,jj,jk) = avm(ji,jj,jk) + zav_tide(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      DO jj = 2, jpjm1
+         DO ji = 2, fpim1
+            DO jk = 2, jpkm1
+               avmu(ji,jj,jk) = avmu(ji,jj,jk) + 0.5 * ( zav_tide(ji,jj,jk) + zav_tide(ji+1,jj  ,jk) ) * umask(ji,jj,jk)
+               avmv(ji,jj,jk) = avmv(ji,jj,jk) + 0.5 * ( zav_tide(ji,jj,jk) + zav_tide(ji  ,jj+1,jk) ) * vmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+#else
       DO jk = 2, jpkm1              !* update momentum & tracer diffusivity with tidal mixing
          avt(:,:,jk) = avt(:,:,jk) + zav_tide(:,:,jk)
@@ -169,4 +214,5 @@
          END DO
       END DO
+#endif
       CALL lbc_lnk( avmu, 'U', 1. )   ;   CALL lbc_lnk( avmv, 'V', 1. )      ! lateral boundary condition
 
@@ -208,7 +254,13 @@
       USE wrk_nemo, ONLY: zempba_3d   => wrk_3d_3, zdn2dz      => wrk_3d_4
       USE wrk_nemo, ONLY: zavt_itf    => wrk_3d_5
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zempba_3d_1 zempba_3d_2 zempba_3d zdn2dz zavt_itf :I :I :z
       !!
       INTEGER , INTENT(in   )                         ::   kt   ! ocean time-step
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pav  ! Tidal mixing coef.
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pav  ! Tidal mixing coef.
+!FTRANS pav :I :I :z
+      REAL(wp), INTENT(inout)            ::   pav(jpi,jpj,jpk)  ! Tidal mixing coef.
       !! 
       INTEGER  ::   ji, jj, jk    ! dummy loop indices
@@ -221,4 +273,17 @@
       END IF
       !                             ! compute the form function using N2 at each time step
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1             
+               zdn2dz     (ji,jj,jk) = rn2(ji,jj,jk) - rn2(ji,jj,jk+1)         ! Vertical profile of dN2/dz
+               zempba_3d_1(ji,jj,jk) = SQRT(  MAX( 0.e0, rn2(ji,jj,jk) )  )    !    -        -    of N
+               zempba_3d_2(ji,jj,jk) =        MAX( 0.e0, rn2(ji,jj,jk) )       !    -        -    of N^2
+            END DO
+            zempba_3d_1(ji,jj,jpk) = 0.e0
+            zempba_3d_2(ji,jj,jpk) = 0.e0
+         END DO
+      END DO
+#else
       zempba_3d_1(:,:,jpk) = 0.e0
       zempba_3d_2(:,:,jpk) = 0.e0
@@ -229,6 +294,20 @@
          zempba_3d_2(:,:,jk) =        MAX( 0.e0, rn2(:,:,jk) )       !    -        -    of N^2
       END DO
-      !
-      zsum (:,:) = 0.e0
+#endif
+      !
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpj
+            zsum1(ji,jj) = 0.e0
+            zsum2(ji,jj) = 0.e0
+            DO jk= 2, jpk
+               zsum1(ji,jj) = zsum1(ji,jj) + zempba_3d_1(ji,jj,jk) * fse3w(ji,jj,jk)
+               zsum2(ji,jj) = zsum2(ji,jj) + zempba_3d_2(ji,jj,jk) * fse3w(ji,jj,jk)                
+            END DO
+            IF( zsum1(ji,jj) /= 0.e0 )   zsum1(ji,jj) = 1.e0 / zsum1(ji,jj)
+            IF( zsum2(ji,jj) /= 0.e0 )   zsum2(ji,jj) = 1.e0 / zsum2(ji,jj)                
+         END DO
+      END DO
+#else
       zsum1(:,:) = 0.e0
       zsum2(:,:) = 0.e0
@@ -243,8 +322,17 @@
          END DO
       END DO
-
-      DO jk= 1, jpk
-         DO jj = 1, jpj
-            DO ji = 1, jpi
+#endif
+
+      zsum (:,:) = 0.e0
+
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpk
+#else
+      DO jk = 1, jpk
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+#endif
                zcoef = 0.5 - SIGN( 0.5, zdn2dz(ji,jj,jk) )       ! =0 if dN2/dz > 0, =1 otherwise 
                ztpc  = zempba_3d_1(ji,jj,jk) * zsum1(ji,jj) *        zcoef     &
@@ -254,8 +342,10 @@
                zsum     (ji,jj)    = zsum(ji,jj) + ztpc * fse3w(ji,jj,jk)
             END DO
+#if !defined key_z_first
          END DO
        END DO
        DO jj = 1, jpj
           DO ji = 1, jpi
+#endif
              IF( zsum(ji,jj) > 0.e0 )   zsum(ji,jj) = 1.e0 / zsum(ji,jj)                
           END DO
@@ -264,13 +354,36 @@
       !                             ! first estimation bounded by 10 cm2/s (with n2 bounded by rn_n2min) 
       zcoef = rn_tfe_itf / ( rn_tfe * rau0 )
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpk
+                zavt_itf(ji,jj,jk) = MIN(  10.e-4, zcoef * en_tmx(ji,jj) * zsum(ji,jj) * zempba_3d(ji,jj,jk)   &
+            &                                             / MAX( rn_n2min, rn2(ji,jj,jk) ) * tmask(ji,jj,jk)  )
+             END DO
+         END DO
+      END DO           
+#else
       DO jk = 1, jpk
          zavt_itf(:,:,jk) = MIN(  10.e-4, zcoef * en_tmx(:,:) * zsum(:,:) * zempba_3d(:,:,jk)   &
             &                                      / MAX( rn_n2min, rn2(:,:,jk) ) * tmask(:,:,jk)  )
       END DO           
-
+#endif
+
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            zkz(ji,jj) = 0.e0       ! Associated potential energy consummed over the whole water column
+            DO jk = 2, jpkm1
+               zkz(ji,jj) = zkz(ji,jj) + fse3w(ji,jj,jk)   &
+                  &                     * MAX( 0.e0, rn2(ji,jj,jk) ) * rau0 * zavt_itf(ji,jj,jk) * tmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+#else
       zkz(:,:) = 0.e0               ! Associated potential energy consummed over the whole water column
       DO jk = 2, jpkm1
          zkz(:,:) = zkz(:,:) + fse3w(:,:,jk) * MAX( 0.e0, rn2(:,:,jk) ) * rau0 * zavt_itf(:,:,jk) * tmask(:,:,jk)
       END DO
+#endif
 
       DO jj = 1, jpj                ! Here zkz should be equal to en_tmx ==> multiply by en_tmx/zkz to recover en_tmx
@@ -280,13 +393,30 @@
       END DO
 
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            zcoef = MIN( zkz(:,:), 120./10. )                              ! kz max = 120 cm2/s
+            DO jk = 2, jpkm1        ! Mutiply by zkz to recover en_tmx, BUT bound by 30/6 ==> zavt_itf bound by 300 cm2/s
+               zavt_itf(ji,jj,jk) = zavt_itf(ji,jj,jk) * zcoef
+            END DO
+         END DO
+      END DO
+#else
       DO jk = 2, jpkm1              ! Mutiply by zkz to recover en_tmx, BUT bound by 30/6 ==> zavt_itf bound by 300 cm2/s
          zavt_itf(:,:,jk) = zavt_itf(:,:,jk) * MIN( zkz(:,:), 120./10. )   ! kz max = 120 cm2/s
       END DO
-
-      IF( kt == nit000 ) THEN       ! diagnose the nergy consumed by zavt_itf
+#endif
+
+      IF( kt == nit000 ) THEN       ! diagnose the energy consumed by zavt_itf
          ztpc = 0.e0
-         DO jk= 1, jpk
-            DO jj= 1, jpj
-               DO ji= 1, jpi
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpk
+#else
+         DO jk = 1, jpk
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+#endif
                   ztpc = ztpc + e1t(ji,jj) * e2t(ji,jj) * fse3w(ji,jj,jk) * MAX( 0.e0, rn2(ji,jj,jk) )   &
                      &                     * zavt_itf(ji,jj,jk) * tmask(ji,jj,jk) * tmask_i(ji,jj)
@@ -299,8 +429,19 @@
 
       !                             ! Update pav with the ITF mixing coefficient
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 2, jpkm1
+               pav(ji,jj,jk) = pav     (ji,jj,jk) * ( 1.e0 - mask_itf(ji,jj) )   &
+            &                + zavt_itf(ji,jj,jk) *          mask_itf(ji,jj) 
+            END DO
+         END DO
+      END DO
+#else
       DO jk = 2, jpkm1
          pav(:,:,jk) = pav     (:,:,jk) * ( 1.e0 - mask_itf(:,:) )   &
             &        + zavt_itf(:,:,jk) *          mask_itf(:,:) 
       END DO
+#endif
       !
       IF( wrk_not_released(2, 2,3,4,5) .OR. &
@@ -311,4 +452,9 @@
    END SUBROUTINE tmx_itf
 
+   !! * Reset control of array index permutation
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+!FTRANS az_tmx :I :I :z
 
    SUBROUTINE zdf_tmx_init
@@ -354,8 +500,16 @@
       USE wrk_nemo, ONLY:   zhdep    =>  wrk_2d_5   ! Ocean depth 
       USE wrk_nemo, ONLY:   zpc      =>  wrk_3d_1   ! power consumption
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zpc :I :I :z
+
       !!
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
       INTEGER  ::   inum         ! local integer
       REAL(wp) ::   ztpc, ze_z   ! local scalars
+#if defined key_z_first
+      REAL(wp) ::   zcoef        ! local scalar
+#endif
+
       !!
       NAMELIST/namzdf_tmx/ rn_htmx, rn_n2min, rn_tfe, rn_me, ln_tmx_itf, rn_tfe_itf
@@ -414,7 +568,13 @@
          END DO
       END DO
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk= 1, jpk           ! complete with the level-dependent part
+#else
       DO jk= 1, jpk                 ! complete with the level-dependent part
          DO jj = 1, jpj
             DO ji = 1, jpi
+#endif
                az_tmx(ji,jj,jk) = zfact(ji,jj) * EXP( -( zhdep(ji,jj)-fsdepw(ji,jj,jk) ) / rn_htmx ) * tmask(ji,jj,jk)
             END DO
@@ -426,14 +586,32 @@
          ! Total power consumption due to vertical mixing
          ! zpc = rau0 * 1/rn_me * rn2 * zav_tide
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zav_tide(ji,jj,1) = 0.e0
+               DO jk = 2, jpkm1
+                  zav_tide(:,:,jk) = az_tmx(:,:,jk) / MAX( rn_n2min, rn2(:,:,jk) )
+               END DO
+               zav_tide(ji,jj,jpk) = 0.e0
+            END DO
+         END DO
+#else
          zav_tide(:,:,:) = 0.e0
          DO jk = 2, jpkm1
             zav_tide(:,:,jk) = az_tmx(:,:,jk) / MAX( rn_n2min, rn2(:,:,jk) )
          END DO
+#endif
 
          ztpc = 0.e0
          zpc(:,:,:) = MAX(rn_n2min,rn2(:,:,:)) * zav_tide(:,:,:)
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk= 2, jpkm1
+#else
          DO jk= 2, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   ztpc = ztpc + fse3w(ji,jj,jk) * e1t(ji,jj) * e2t(ji,jj) * zpc(ji,jj,jk) * tmask(ji,jj,jk) * tmask_i(ji,jj)
                END DO
@@ -448,11 +626,19 @@
          ! control print 2
          zav_tide(:,:,:) = MIN( zav_tide(:,:,:), 60.e-4 )   
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zkz(ji,jj) = 0.e0
+               DO jk = 2, jpkm1
+#else
          zkz(:,:) = 0.e0
          DO jk = 2, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zkz(ji,jj) = zkz(ji,jj) + fse3w(ji,jj,jk) * MAX( 0.e0, rn2(ji,jj,jk) ) * rau0 * zav_tide(ji,jj,jk)* tmask(ji,jj,jk)
-            END DO
-         END DO
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+#endif
+                  zkz(ji,jj) = zkz(ji,jj) + fse3w(ji,jj,jk)   &
+                     &                     * MAX( 0.e0, rn2(ji,jj,jk) ) * rau0 * zav_tide(ji,jj,jk)* tmask(ji,jj,jk)
+               END DO
+            END DO
          END DO
          ! Here zkz should be equal to en_tmx ==> multiply by en_tmx/zkz
@@ -468,18 +654,35 @@
             DO ji = 1, jpi
                IF( zkz(ji,jj) /= 0.e0 )   THEN
-                   ztpc = Min( zkz(ji,jj), ztpc)
+                   ztpc = MIN( zkz(ji,jj), ztpc)
                ENDIF
             END DO
          END DO
-         WRITE(numout,*) '          Min de zkz ', ztpc, ' Max = ', maxval(zkz(:,:) )
-
+         WRITE(numout,*) '          Min de zkz ', ztpc, ' Max = ', MAXVAL(zkz(:,:) )
+
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zcoef = MIN( zkz(ji,jj), 30./6. )                            !kz max = 300 cm2/s
+               DO jk = 2, jpkm1
+                  zav_tide(ji,jj,jk) = zav_tide(ji,jj,jk) * zcoef
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 2, jpkm1
             zav_tide(:,:,jk) = zav_tide(:,:,jk) * MIN( zkz(:,:), 30./6. )   !kz max = 300 cm2/s
          END DO
+#endif
          ztpc = 0.e0
-         zpc(:,:,:) = Max(0.e0,rn2(:,:,:)) * zav_tide(:,:,:)
+         zpc(:,:,:) = MAX(0.e0,rn2(:,:,:)) * zav_tide(:,:,:)
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk= 1, jpk
+#else
          DO jk= 1, jpk
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   ztpc = ztpc + fse3w(ji,jj,jk) * e1t(ji,jj) * e2t(ji,jj) * zpc(ji,jj,jk) * tmask(ji,jj,jk) * tmask_i(ji,jj)
                END DO
